OGRE: Ogre::v1::BillboardParticleRenderer Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::v1::BillboardParticleRenderer Class Reference
Core » Effects

Specialisation of ParticleSystemRenderer to render particles using a BillboardSet. More...

`#include <OgreBillboardParticleRenderer.h>`

Inheritance diagram for Ogre::v1::BillboardParticleRenderer:
[legend]

## Classes
class | CmdAccurateFacing
| Command object for accurate facing(see ParamCommand). More...
class | CmdBillboardOrigin
| Command object for billboard origin (see ParamCommand). More...
class | CmdBillboardRotationType
| Command object for billboard rotation type (see ParamCommand). More...
class | CmdBillboardType
| Command object for billboard type (see ParamCommand). More...
class | CmdCommonDirection
| Command object for common direction (see ParamCommand). More...
class | CmdCommonUpVector
| Command object for common up-vector (see ParamCommand). More...
class | CmdPointRendering
| Command object for point rendering (see ParamCommand). More...

## Public Member Functions
| BillboardParticleRenderer (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *sceneManager)
| ~BillboardParticleRenderer ()
virtual ParticleVisualData * | _createVisualData (void)
| Create a new ParticleVisualData instance for attachment to a particle. More...
virtual void | _destroyVisualData (ParticleVisualData *vis)
| Destroy a ParticleVisualData instance. More...
SortMode | _getSortMode (void) const
| Gets the desired particles sort mode of this renderer. More...
void | _notifyAttached (Node *parent)
| Delegated to by ParticleSystem::_notifyAttached. More...
void | _notifyCurrentCamera (const Camera *cam)
| Delegated to by ParticleSystem::_notifyCurrentCamera. More...
void | _notifyDefaultDimensions (Real width, Real height)
| Tells the renderer that the particle default size has changed. More...
virtual void | _notifyParticleCleared (list< Particle * >::type &currentParticles)
| Optional callback notified when particles cleared. More...
virtual void | _notifyParticleEmitted (Particle *particle)
| Optional callback notified when particle emitted. More...
virtual void | _notifyParticleExpired (Particle *particle)
| Optional callback notified when particle expired. More...
virtual void | _notifyParticleMoved (list< Particle * >::type &currentParticles)
| Optional callback notified when particles moved. More...
void | _notifyParticleQuota (size_t quota)
| Tells the renderer that the particle quota has changed. More...
void | _notifyParticleResized (void)
| Optional callback notified when particles are resized individually. More...
void | _notifyParticleRotated (void)
| Optional callback notified when particles are rotated. More...
virtual void | _setDatablock (HlmsDatablock *datablock)
| Sets the HLMS material this renderer must use; called by ParticleSystem. More...
virtual void | _setMaterialName (const String &matName, const String &resourceGroup)
| Sets the material this renderer must use; called by ParticleSystem. More...
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera, list< Particle * >::type &currentParticles, bool cullIndividually, RenderableArray &outRenderables)
| Delegated to by ParticleSystem::_updateRenderQueue. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
BillboardOrigin | getBillboardOrigin (void) const
| Gets the point which acts as the origin point for all billboards in this set. More...
BillboardRotationType | getBillboardRotationType (void) const
| Gets billboard rotation type. More...
BillboardSet * | getBillboardSet (void) const
| Access BillboardSet in use. More...
BillboardType | getBillboardType (void) const
| Returns the billboard type in use. More...
const Vector3 & | getCommonDirection (void) const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON) More...
const Vector3 & | getCommonUpVector (void) const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF) More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
const String & | getType (void) const
| Gets the type of this renderer - must be implemented by subclasses. More...
bool | getUseAccurateFacing (void) const
| Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction. More...
bool | isPointRenderingEnabled (void) const
| Returns whether point rendering is enabled. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set. More...
void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type. More...
void | setBillboardType (BillboardType bbt)
| Sets the type of billboard to render. More...
void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON. More...
void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF. More...
void | setKeepParticlesInLocalSpace (bool keepLocal)
| Setting carried over from ParticleSystem. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setPointRenderingEnabled (bool enabled)
| Set whether or not the BillboardSet will use point rendering rather than manually generated quads. More...
void | setRenderQueueGroup (uint8 queueID)
| Sets which render queue group this renderer should target with it's output. More...
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setUseAccurateFacing (bool acc)
| Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Detailed Description

Specialisation of ParticleSystemRenderer to render particles using a BillboardSet.

Remarks
  This renderer has a few more options than the standard particle system, which will be passed to it automatically when the particle system itself does not understand them.

## Constructor & Destructor Documentation

## ◆ BillboardParticleRenderer()

Ogre::v1::BillboardParticleRenderer::BillboardParticleRenderer | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | sceneManager
| ) |  |

## ◆ ~BillboardParticleRenderer()

Ogre::v1::BillboardParticleRenderer::~BillboardParticleRenderer | ( |  | ) |

## Member Function Documentation

## ◆ _createVisualData()

virtual ParticleVisualData* Ogre::ParticleSystemRenderer::_createVisualData | ( | void |  | ) |
| inlinevirtualinherited

Create a new ParticleVisualData instance for attachment to a particle.

Remarks
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to return a new instance of it. The default behaviour is to return null.

## ◆ _destroyVisualData()

virtual void Ogre::ParticleSystemRenderer::_destroyVisualData | ( | ParticleVisualData * | vis | ) |
| inlinevirtualinherited

Destroy a ParticleVisualData instance.

Remarks
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to destroy an instance of it. The default behaviour is to do nothing.

## ◆ _getSortMode()

SortMode Ogre::v1::BillboardParticleRenderer::_getSortMode | ( | void |  | ) | const
| virtual

Gets the desired particles sort mode of this renderer.

Implements Ogre::ParticleSystemRenderer.

## ◆ _notifyAttached()

void Ogre::v1::BillboardParticleRenderer::_notifyAttached | ( | Node * | parent | ) |
| virtual

Delegated to by ParticleSystem::_notifyAttached.

Implements Ogre::ParticleSystemRenderer.

## ◆ _notifyCurrentCamera()

void Ogre::v1::BillboardParticleRenderer::_notifyCurrentCamera | ( | const Camera * | cam | ) |
| virtual

Delegated to by ParticleSystem::_notifyCurrentCamera.

Implements Ogre::ParticleSystemRenderer.

## ◆ _notifyDefaultDimensions()

void Ogre::v1::BillboardParticleRenderer::_notifyDefaultDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| virtual

Tells the renderer that the particle default size has changed.

Implements Ogre::ParticleSystemRenderer.

## ◆ _notifyParticleCleared()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleCleared | ( | list< Particle * >::type & | currentParticles | ) |
| inlinevirtualinherited

Optional callback notified when particles cleared.

## ◆ _notifyParticleEmitted()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleEmitted | ( | Particle * | particle | ) |
| inlinevirtualinherited

Optional callback notified when particle emitted.

## ◆ _notifyParticleExpired()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleExpired | ( | Particle * | particle | ) |
| inlinevirtualinherited

Optional callback notified when particle expired.

## ◆ _notifyParticleMoved()

virtual void Ogre::ParticleSystemRenderer::_notifyParticleMoved | ( | list< Particle * >::type & | currentParticles | ) |
| inlinevirtualinherited

Optional callback notified when particles moved.

## ◆ _notifyParticleQuota()

void Ogre::v1::BillboardParticleRenderer::_notifyParticleQuota | ( | size_t | quota | ) |
| virtual

Tells the renderer that the particle quota has changed.

Implements Ogre::ParticleSystemRenderer.

## ◆ _notifyParticleResized()

void Ogre::v1::BillboardParticleRenderer::_notifyParticleResized | ( | void |  | ) |
| virtual

Optional callback notified when particles are resized individually.

Reimplemented from Ogre::ParticleSystemRenderer.

## ◆ _notifyParticleRotated()

void Ogre::v1::BillboardParticleRenderer::_notifyParticleRotated | ( | void |  | ) |
| virtual

Optional callback notified when particles are rotated.

Reimplemented from Ogre::ParticleSystemRenderer.

## ◆ _setDatablock()

virtual void Ogre::v1::BillboardParticleRenderer::_setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtual

Sets the HLMS material this renderer must use; called by ParticleSystem.

Implements Ogre::ParticleSystemRenderer.

## ◆ _setMaterialName()

virtual void Ogre::v1::BillboardParticleRenderer::_setMaterialName | ( | const String & | matName,
|  | const String & | resourceGroup
| ) |  |
| virtual

Sets the material this renderer must use; called by ParticleSystem.

Implements Ogre::ParticleSystemRenderer.

## ◆ _updateRenderQueue()

void Ogre::v1::BillboardParticleRenderer::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera,
|  | list< Particle * >::type & | currentParticles,
|  | bool | cullIndividually,
|  | RenderableArray & | outRenderables
| ) |  |
| virtual

Delegated to by ParticleSystem::_updateRenderQueue.

Remarks
  The subclass must update the render queue using whichever Renderable instance(s) it wishes.

Implements Ogre::ParticleSystemRenderer.

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ getBillboardOrigin()

BillboardOrigin Ogre::v1::BillboardParticleRenderer::getBillboardOrigin | ( | void |  | ) | const
| inline

Gets the point which acts as the origin point for all billboards in this set.

Returns
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

References Ogre::v1::BillboardSet::getBillboardOrigin().

## ◆ getBillboardRotationType()

BillboardRotationType Ogre::v1::BillboardParticleRenderer::getBillboardRotationType | ( | void |  | ) | const

Gets billboard rotation type.

Returns
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ getBillboardSet()

BillboardSet* Ogre::v1::BillboardParticleRenderer::getBillboardSet | ( | void |  | ) | const
| inline

Access BillboardSet in use.

## ◆ getBillboardType()

BillboardType Ogre::v1::BillboardParticleRenderer::getBillboardType | ( | void |  | ) | const

Returns the billboard type in use.

## ◆ getCommonDirection()

const Vector3& Ogre::v1::BillboardParticleRenderer::getCommonDirection | ( | void |  | ) | const

Gets the common direction for all billboards (BBT_ORIENTED_COMMON)

## ◆ getCommonUpVector()

const Vector3& Ogre::v1::BillboardParticleRenderer::getCommonUpVector | ( | void |  | ) | const

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF)

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getType()

const String& Ogre::v1::BillboardParticleRenderer::getType | ( | void |  | ) | const
| virtual

Gets the type of this renderer - must be implemented by subclasses.

Implements Ogre::ParticleSystemRenderer.

## ◆ getUseAccurateFacing()

bool Ogre::v1::BillboardParticleRenderer::getUseAccurateFacing | ( | void |  | ) | const

Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

## ◆ isPointRenderingEnabled()

bool Ogre::v1::BillboardParticleRenderer::isPointRenderingEnabled | ( | void |  | ) | const

Returns whether point rendering is enabled.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ setBillboardOrigin()

void Ogre::v1::BillboardParticleRenderer::setBillboardOrigin | ( | BillboardOrigin | origin | ) |
| inline

Sets the point which acts as the origin point for all billboards in this set.

Remarks
  This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

  The default setting is BBO_CENTER.

Parameters

  origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

References Ogre::v1::BillboardSet::setBillboardOrigin().

## ◆ setBillboardRotationType()

void Ogre::v1::BillboardParticleRenderer::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) |

Sets billboard rotation type.

Remarks
  This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

  The default settings is BBR_TEXCOORD.

Parameters

  rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ setBillboardType()

void Ogre::v1::BillboardParticleRenderer::setBillboardType | ( | BillboardType | bbt | ) |

Sets the type of billboard to render.

Remarks
  The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independent Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

Parameters

  bbt | The type of billboard to render

## ◆ setCommonDirection()

void Ogre::v1::BillboardParticleRenderer::setCommonDirection | ( | const Vector3 & | vec | ) |

Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON.

Remarks
  Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

Parameters

  vec | The direction for all billboards.

## ◆ setCommonUpVector()

void Ogre::v1::BillboardParticleRenderer::setCommonUpVector | ( | const Vector3 & | vec | ) |

Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF.

Remarks
  Use BBT_PERPENDICULAR_SELF when you want oriented billboards perpendicular to their own direction vector and doesn't face to camera. In this case, we need an additional vector to determine the billboard X, Y axis. The generated X axis perpendicular to both the own direction and up-vector, the Y axis will coplanar with both own direction and up-vector, and perpendicular to own direction.

Parameters

  vec | The up-vector for all billboards.

## ◆ setKeepParticlesInLocalSpace()

void Ogre::v1::BillboardParticleRenderer::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) |
| virtual

Setting carried over from ParticleSystem.

Implements Ogre::ParticleSystemRenderer.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setPointRenderingEnabled()

void Ogre::v1::BillboardParticleRenderer::setPointRenderingEnabled | ( | bool | enabled | ) |

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

Remarks
  By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

  Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:
  - Only the BBT_POINT type is supported
  - Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled)
  - Per-billboard size is not supported (stems from the above)
  - Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
  - Only BBO_CENTER origin is supported
  - Per-billboard texture coordinates are not supported

  You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

Parameters

  enabled | True to enable point rendering, false otherwise

## ◆ setRenderQueueGroup()

void Ogre::v1::BillboardParticleRenderer::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtual

Sets which render queue group this renderer should target with it's output.

Implements Ogre::ParticleSystemRenderer.

## ◆ setRenderQueueSubGroup()

void Ogre::v1::BillboardParticleRenderer::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| virtual

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

Implements Ogre::ParticleSystemRenderer.

## ◆ setUseAccurateFacing()

void Ogre::v1::BillboardParticleRenderer::setUseAccurateFacing | ( | bool | acc | ) |

Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Remarks
  By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters

  acc | True to use the slower but more accurate model. Default is false.

The documentation for this class was generated from the following file:

- OgreBillboardParticleRenderer.h